# gem-data-proc
## Description
Scripts library used to capture, process and plot data during system testing. Original use for Fast-Track testing, it can be adapted to other needs

### Scripts
* `dataFromGea.py` - Short library which provides a way to get data from Gea
* `inPosDataCap.py` - Main script to gather data from Telescope subsystems. It outputs a `h5df` file, with the data organized in groups. It has two modes of use:
    * `ca` - Captures data using channel access. Used for real time capture
    * `gea` - Gets data from gea. Used when you want access to older data, that wasn't captured in real time
* `plotEpicsData.py` - Library containing the classes used to generate analysis plots. It also has a collection of data processing functions
* `plotFTV2.py` - Example script, which generates timestamp diff and histogram of tcs:drives:driveMCS.VALI[4] and cr:crFollowA.J[1]. Note: This script will change and moved in future commits
## Brief user guide

The script `inPosDataCap.py` has a help feature that can be accessed by the following commands

<pre>
$> ./inPosDataCap.py -h
$> ./inPosDataCap.py ca -h
$> ./inPosDataCap.py gea -h
</pre>

To capture data from the telescope using channel access (CA) a plain txt file is needed. This file specifies the channels to be acquired. An example of a data capture launch would be follows:

<pre>
$> ./inPosDataCap.py ca tcs-chans.txt -hr 3
</pre>

This would launch the data acquisition for 3 hours
The `tcs-chans.txt` file could look as follows

<pre>
#TCS - MCS Demands
tcs:drives:driveMCS.VALI
#TCS - CRCS Demands
tcs:drives:driveCRS.VALA
</pre>

To extract data from GEA, a plain txt file can be used, or a single channel can be specified. An example GEA is extraction is shown below

<pre>
$> ./inPosDataCap.py gea gn tcs:drives:driveMCS.VALA "210110T020000" "210110T021500" -rn
</pre>

This would capture 15 min of data for `tcs:drives:driveMCS.VALA`, and generate the corresponding hdf5 file.

To generate the example plot, execute the following

<pre>
$> ./plotFTV2.py recMonCA-20210125T130238.h5
</pre>

where `recMonCA-20210125T130238.h5` is a file generated by `inPosDataCap.py`
